Index: /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/Debug/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/Debug/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/Debug/Makefile	(revision 340)
@@ -188,6 +188,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -196,5 +199,5 @@
 #
 APPLNAME = app1_usb_watt_meter
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/DebugCitrus/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/DebugCitrus/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/DebugCitrus/Makefile	(revision 340)
@@ -188,6 +188,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -196,5 +199,5 @@
 #
 APPLNAME = app1_usb_watt_meter
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/DebugEther/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/DebugEther/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/DebugEther/Makefile	(revision 340)
@@ -188,6 +188,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -196,5 +199,5 @@
 #
 APPLNAME = app1_usb_watt_meter
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/src/echonet_main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/src/echonet_main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/src/echonet_main.c	(revision 340)
@@ -61,5 +61,5 @@
 
 /* TODO: メーカーコードを設定 */
-#define MAKER_CODE	0x00, 0x00, 0xB3	/* TOPPERSプロジェクト */
+#define MAKER_CODE	{ 0x00, 0x00, 0xB3 }	/* TOPPERSプロジェクト */
 
 /* ノードプロファイルオブジェクト */
Index: /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/src/main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/src/main.c	(revision 340)
@@ -76,4 +76,5 @@
 #include <btstack/utils.h>
 #include "client.h"
+#include "ntp_cli.h"
 
 ID ws_api_mailboxid = MAIN_DATAQUEUE;
@@ -309,4 +310,7 @@
 	}
 
+	if (link_up && up)
+		ntp_cli_execute();
+
 	ntshell_change_netif_link(link_up, up);
 
@@ -338,4 +342,5 @@
 extern int usrcmd_dhcp4c(int argc, char **argv);
 extern int usrcmd_dnsc(int argc, char **argv);
+extern int usrcmd_ntpc(int argc, char **argv);
 
 static const cmd_table_t cmdlist[] = {
@@ -347,8 +352,10 @@
 	{"mkdir", "Make directory", usrcmd_mkdir},
 	{"hexdump", "Hex dump", usrcmd_hexdump},
+	{"date", "print date and time", usrcmd_date},
 	{"curl", "Command lines or scripts to transfer data", curl_main},
 	{"ping", "ping", usrcmd_ping},
-	{"dhcpc", "DHCP client rel/renew/info", usrcmd_dhcp4c},
+	{"dhcpc", "DHCP Client rel/renew/info", usrcmd_dhcp4c},
 	{"dnsc", "DNS client", usrcmd_dnsc },
+	{"ntpc", "NTP client", usrcmd_ntpc },
 	{"logupload", "Upload log to server", cmd_logupload},
 	{"info", "This is a description text string for info command.", usrcmd_info},
Index: /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/src/main.cfg
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/src/main.cfg	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/src/main.cfg	(revision 340)
@@ -58,5 +58,5 @@
 /* DHCP クライアント */
 #include "netapp/dhcp4_cli.h"
-INCLUDE("netapp/dhcp4_cli_asp.cfg");
+//INCLUDE("netapp/dhcp4_cli_asp.cfg");
 INCLUDE("netapp/tinet_dhcp4_cli.cfg");
 
@@ -65,4 +65,12 @@
 INCLUDE("netapp/resolver_asp.cfg");
 INCLUDE("netapp/tinet_resolver.cfg");
+
+/* NTPクライアント */
+#include "ntp_cli.h"
+//INCLUDE("ntp_cli.cfg");
+INCLUDE("tinet_ntp_cli.cfg");
+
+#include "net_misc.h"
+INCLUDE("net_misc.cfg");
 
 /* FatFs */
Index: /asp3_tinet_ecnl_rx/trunk/app2_light/Debug/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app2_light/Debug/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app2_light/Debug/Makefile	(revision 340)
@@ -179,6 +179,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -187,5 +190,5 @@
 #
 APPLNAME = app2_light
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app2_light/DebugCitrus/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app2_light/DebugCitrus/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app2_light/DebugCitrus/Makefile	(revision 340)
@@ -179,6 +179,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -187,5 +190,5 @@
 #
 APPLNAME = app2_light
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app2_light/DebugEther/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app2_light/DebugEther/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app2_light/DebugEther/Makefile	(revision 340)
@@ -177,6 +177,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -185,5 +188,5 @@
 #
 APPLNAME = app2_light
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app2_light/src/echonet_main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app2_light/src/echonet_main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app2_light/src/echonet_main.c	(revision 340)
@@ -53,5 +53,5 @@
 
 /* TODO: メーカーコードを設定 */
-#define MAKER_CODE	0x00, 0x00, 0xB3	/* TOPPERSプロジェクト */
+#define MAKER_CODE	{ 0x00, 0x00, 0xB3 }	/* TOPPERSプロジェクト */
 
 /* ノードプロファイルオブジェクト */
Index: /asp3_tinet_ecnl_rx/trunk/app2_light/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app2_light/src/main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app2_light/src/main.c	(revision 340)
@@ -75,4 +75,5 @@
 #include "ntshell_main.h"
 #include <btstack/utils.h>
+#include "ntp_cli.h"
 
 ID ws_api_mailboxid = MAIN_DATAQUEUE;
@@ -301,4 +302,7 @@
 	}
 
+	if (link_up && up)
+		ntp_cli_execute();
+
 	ntshell_change_netif_link(link_up, up);
 
@@ -308,4 +312,5 @@
 extern int usrcmd_ping(int argc, char **argv);
 extern int usrcmd_dhcp4c(int argc, char **argv);
+extern int usrcmd_dnsc(int argc, char **argv);
 
 static const cmd_table_t cmdlist[] = {
@@ -317,6 +322,8 @@
 	{"mkdir", "Make directory", usrcmd_mkdir},
 	{"hexdump", "Hex dump", usrcmd_hexdump},
+	{"date", "print date and time", usrcmd_date},
 	{"ping", "ping", usrcmd_ping},
 	{"dhcpc", "DHCP Client rel/renew/info", usrcmd_dhcp4c},
+	{"dnsc", "DNS client", usrcmd_dnsc },
 	{"info", "This is a description text string for info command.", usrcmd_info},
 	{"exit", "Exit Natural Tiny Shell", usrcmd_exit},
Index: /asp3_tinet_ecnl_rx/trunk/app2_light/src/main.cfg
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app2_light/src/main.cfg	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app2_light/src/main.cfg	(revision 340)
@@ -58,5 +58,5 @@
 /* DHCP クライアント */
 #include "netapp/dhcp4_cli.h"
-INCLUDE("netapp/dhcp4_cli_asp.cfg");
+//INCLUDE("netapp/dhcp4_cli_asp.cfg");
 INCLUDE("netapp/tinet_dhcp4_cli.cfg");
 
@@ -65,4 +65,12 @@
 INCLUDE("netapp/resolver_asp.cfg");
 INCLUDE("netapp/tinet_resolver.cfg");
+
+/* NTPクライアント */
+#include "ntp_cli.h"
+//INCLUDE("ntp_cli.cfg");
+INCLUDE("tinet_ntp_cli.cfg");
+
+#include "net_misc.h"
+INCLUDE("net_misc.cfg");
 
 /* FatFs */
Index: /asp3_tinet_ecnl_rx/trunk/app3_human_detec/Debug/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app3_human_detec/Debug/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app3_human_detec/Debug/Makefile	(revision 340)
@@ -179,6 +179,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -187,5 +190,5 @@
 #
 APPLNAME = app3_human_detec
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app3_human_detec/DebugCitrus/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app3_human_detec/DebugCitrus/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app3_human_detec/DebugCitrus/Makefile	(revision 340)
@@ -179,6 +179,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -187,5 +190,5 @@
 #
 APPLNAME = app3_human_detec
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app3_human_detec/DebugEther/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app3_human_detec/DebugEther/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app3_human_detec/DebugEther/Makefile	(revision 340)
@@ -177,6 +177,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -185,5 +188,5 @@
 #
 APPLNAME = app3_human_detec
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/echonet_main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/echonet_main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/echonet_main.c	(revision 340)
@@ -53,5 +53,5 @@
 
 /* TODO: メーカーコードを設定 */
-#define MAKER_CODE	0x00, 0x00, 0xB3	/* TOPPERSプロジェクト */
+#define MAKER_CODE	{ 0x00, 0x00, 0xB3 }	/* TOPPERSプロジェクト */
 
 /* ノードプロファイルオブジェクト */
Index: /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/main.c	(revision 340)
@@ -75,4 +75,5 @@
 #include "ntshell_main.h"
 #include <btstack/utils.h>
+#include "ntp_cli.h"
 
 ID ws_api_mailboxid = MAIN_DATAQUEUE;
@@ -301,4 +302,7 @@
 	}
 
+	if (link_up && up)
+		ntp_cli_execute();
+
 	ntshell_change_netif_link(link_up, up);
 
@@ -308,4 +312,5 @@
 extern int usrcmd_ping(int argc, char **argv);
 extern int usrcmd_dhcp4c(int argc, char **argv);
+extern int usrcmd_dnsc(int argc, char **argv);
 
 static const cmd_table_t cmdlist[] = {
@@ -317,6 +322,8 @@
 	{"mkdir", "Make directory", usrcmd_mkdir},
 	{"hexdump", "Hex dump", usrcmd_hexdump},
+	{"date", "print date and time", usrcmd_date},
 	{"ping", "ping", usrcmd_ping},
 	{"dhcpc", "DHCP Client rel/renew/info", usrcmd_dhcp4c},
+	{"dnsc", "DNS client", usrcmd_dnsc },
 	{"info", "This is a description text string for info command.", usrcmd_info},
 	{"exit", "Exit Natural Tiny Shell", usrcmd_exit},
Index: /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/main.cfg
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/main.cfg	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/main.cfg	(revision 340)
@@ -58,5 +58,5 @@
 /* DHCP クライアント */
 #include "netapp/dhcp4_cli.h"
-INCLUDE("netapp/dhcp4_cli_asp.cfg");
+//INCLUDE("netapp/dhcp4_cli_asp.cfg");
 INCLUDE("netapp/tinet_dhcp4_cli.cfg");
 
@@ -65,4 +65,12 @@
 INCLUDE("netapp/resolver_asp.cfg");
 INCLUDE("netapp/tinet_resolver.cfg");
+
+/* NTPクライアント */
+#include "ntp_cli.h"
+//INCLUDE("ntp_cli.cfg");
+INCLUDE("tinet_ntp_cli.cfg");
+
+#include "net_misc.h"
+INCLUDE("net_misc.cfg");
 
 /* FatFs */
Index: /asp3_tinet_ecnl_rx/trunk/app4_aircon/Debug/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app4_aircon/Debug/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app4_aircon/Debug/Makefile	(revision 340)
@@ -179,6 +179,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -187,5 +190,5 @@
 #
 APPLNAME = app4_aircon
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app4_aircon/DebugCitrus/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app4_aircon/DebugCitrus/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app4_aircon/DebugCitrus/Makefile	(revision 340)
@@ -179,6 +179,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -187,5 +190,5 @@
 #
 APPLNAME = app4_aircon
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app4_aircon/DebugEther/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app4_aircon/DebugEther/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app4_aircon/DebugEther/Makefile	(revision 340)
@@ -177,6 +177,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -185,5 +188,5 @@
 #
 APPLNAME = app4_aircon
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/echonet_main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/echonet_main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/echonet_main.c	(revision 340)
@@ -53,5 +53,5 @@
 
 /* TODO: メーカーコードを設定 */
-#define MAKER_CODE	0x00, 0x00, 0xB3	/* TOPPERSプロジェクト */
+#define MAKER_CODE	{ 0x00, 0x00, 0xB3 }	/* TOPPERSプロジェクト */
 
 /* ノードプロファイルオブジェクト */
Index: /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/main.c	(revision 340)
@@ -75,4 +75,5 @@
 #include "ntshell_main.h"
 #include <btstack/utils.h>
+#include "ntp_cli.h"
 
 ID ws_api_mailboxid = MAIN_DATAQUEUE;
@@ -301,4 +302,7 @@
 	}
 
+	if (link_up && up)
+		ntp_cli_execute();
+
 	ntshell_change_netif_link(link_up, up);
 
@@ -308,4 +312,5 @@
 extern int usrcmd_ping(int argc, char **argv);
 extern int usrcmd_dhcp4c(int argc, char **argv);
+extern int usrcmd_dnsc(int argc, char **argv);
 
 static const cmd_table_t cmdlist[] = {
@@ -317,6 +322,8 @@
 	{"mkdir", "Make directory", usrcmd_mkdir},
 	{"hexdump", "Hex dump", usrcmd_hexdump},
+	{"date", "print date and time", usrcmd_date},
 	{"ping", "ping", usrcmd_ping},
 	{"dhcpc", "DHCP Client rel/renew/info", usrcmd_dhcp4c},
+	{"dnsc", "DNS client", usrcmd_dnsc },
 	{"info", "This is a description text string for info command.", usrcmd_info},
 	{"exit", "Exit Natural Tiny Shell", usrcmd_exit},
Index: /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/main.cfg
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/main.cfg	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/main.cfg	(revision 340)
@@ -58,5 +58,5 @@
 /* DHCP クライアント */
 #include "netapp/dhcp4_cli.h"
-INCLUDE("netapp/dhcp4_cli_asp.cfg");
+//INCLUDE("netapp/dhcp4_cli_asp.cfg");
 INCLUDE("netapp/tinet_dhcp4_cli.cfg");
 
@@ -65,4 +65,12 @@
 INCLUDE("netapp/resolver_asp.cfg");
 INCLUDE("netapp/tinet_resolver.cfg");
+
+/* NTPクライアント */
+#include "ntp_cli.h"
+//INCLUDE("ntp_cli.cfg");
+INCLUDE("tinet_ntp_cli.cfg");
+
+#include "net_misc.h"
+INCLUDE("net_misc.cfg");
 
 /* FatFs */
Index: /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/Debug/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/Debug/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/Debug/Makefile	(revision 340)
@@ -179,6 +179,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -187,5 +190,5 @@
 #
 APPLNAME = app5_temp_sensor
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/DebugCitrus/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/DebugCitrus/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/DebugCitrus/Makefile	(revision 340)
@@ -179,6 +179,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -187,5 +190,5 @@
 #
 APPLNAME = app5_temp_sensor
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/DebugEther/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/DebugEther/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/DebugEther/Makefile	(revision 340)
@@ -177,6 +177,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -185,5 +188,5 @@
 #
 APPLNAME = app5_temp_sensor
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/echonet_main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/echonet_main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/echonet_main.c	(revision 340)
@@ -53,5 +53,5 @@
 
 /* TODO: メーカーコードを設定 */
-#define MAKER_CODE	0x00, 0x00, 0xB3	/* TOPPERSプロジェクト */
+#define MAKER_CODE	{ 0x00, 0x00, 0xB3 }	/* TOPPERSプロジェクト */
 
 /* ノードプロファイルオブジェクト */
Index: /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/main.c	(revision 340)
@@ -75,4 +75,5 @@
 #include "ntshell_main.h"
 #include <btstack/utils.h>
+#include "ntp_cli.h"
 
 ID ws_api_mailboxid = MAIN_DATAQUEUE;
@@ -301,4 +302,7 @@
 	}
 
+	if (link_up && up)
+		ntp_cli_execute();
+
 	ntshell_change_netif_link(link_up, up);
 
@@ -308,4 +312,5 @@
 extern int usrcmd_ping(int argc, char **argv);
 extern int usrcmd_dhcp4c(int argc, char **argv);
+extern int usrcmd_dnsc(int argc, char **argv);
 
 static const cmd_table_t cmdlist[] = {
@@ -317,6 +322,8 @@
 	{"mkdir", "Make directory", usrcmd_mkdir},
 	{"hexdump", "Hex dump", usrcmd_hexdump},
+	{"date", "print date and time", usrcmd_date},
 	{"ping", "ping", usrcmd_ping},
 	{"dhcpc", "DHCP Client rel/renew/info", usrcmd_dhcp4c},
+	{"dnsc", "DNS client", usrcmd_dnsc },
 	{"info", "This is a description text string for info command.", usrcmd_info},
 	{"exit", "Exit Natural Tiny Shell", usrcmd_exit},
Index: /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/main.cfg
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/main.cfg	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/main.cfg	(revision 340)
@@ -58,5 +58,5 @@
 /* DHCP クライアント */
 #include "netapp/dhcp4_cli.h"
-INCLUDE("netapp/dhcp4_cli_asp.cfg");
+//INCLUDE("netapp/dhcp4_cli_asp.cfg");
 INCLUDE("netapp/tinet_dhcp4_cli.cfg");
 
@@ -65,4 +65,12 @@
 INCLUDE("netapp/resolver_asp.cfg");
 INCLUDE("netapp/tinet_resolver.cfg");
+
+/* NTPクライアント */
+#include "ntp_cli.h"
+//INCLUDE("ntp_cli.cfg");
+INCLUDE("tinet_ntp_cli.cfg");
+
+#include "net_misc.h"
+INCLUDE("net_misc.cfg");
 
 /* FatFs */
Index: /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/Debug/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/Debug/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/Debug/Makefile	(revision 340)
@@ -179,6 +179,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -187,5 +190,5 @@
 #
 APPLNAME = app6_hot_water_pot
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/DebugCitrus/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/DebugCitrus/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/DebugCitrus/Makefile	(revision 340)
@@ -179,6 +179,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -187,5 +190,5 @@
 #
 APPLNAME = app6_hot_water_pot
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/DebugEther/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/DebugEther/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/DebugEther/Makefile	(revision 340)
@@ -177,6 +177,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -185,5 +188,5 @@
 #
 APPLNAME = app6_hot_water_pot
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/echonet_main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/echonet_main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/echonet_main.c	(revision 340)
@@ -53,5 +53,5 @@
 
 /* TODO: メーカーコードを設定 */
-#define MAKER_CODE	0x00, 0x00, 0xB3	/* TOPPERSプロジェクト */
+#define MAKER_CODE	{ 0x00, 0x00, 0xB3 }	/* TOPPERSプロジェクト */
 
 /* ノードプロファイルオブジェクト */
Index: /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/main.c	(revision 340)
@@ -75,4 +75,5 @@
 #include "ntshell_main.h"
 #include <btstack/utils.h>
+#include "ntp_cli.h"
 
 ID ws_api_mailboxid = MAIN_DATAQUEUE;
@@ -301,4 +302,7 @@
 	}
 
+	if (link_up && up)
+		ntp_cli_execute();
+
 	ntshell_change_netif_link(link_up, up);
 
@@ -308,4 +312,5 @@
 extern int usrcmd_ping(int argc, char **argv);
 extern int usrcmd_dhcp4c(int argc, char **argv);
+extern int usrcmd_dnsc(int argc, char **argv);
 
 static const cmd_table_t cmdlist[] = {
@@ -317,6 +322,8 @@
 	{"mkdir", "Make directory", usrcmd_mkdir},
 	{"hexdump", "Hex dump", usrcmd_hexdump},
+	{"date", "print date and time", usrcmd_date},
 	{"ping", "ping", usrcmd_ping},
 	{"dhcpc", "DHCP Client rel/renew/info", usrcmd_dhcp4c},
+	{"dnsc", "DNS client", usrcmd_dnsc },
 	{"info", "This is a description text string for info command.", usrcmd_info},
 	{"exit", "Exit Natural Tiny Shell", usrcmd_exit},
Index: /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/main.cfg
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/main.cfg	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/main.cfg	(revision 340)
@@ -58,5 +58,5 @@
 /* DHCP クライアント */
 #include "netapp/dhcp4_cli.h"
-INCLUDE("netapp/dhcp4_cli_asp.cfg");
+//INCLUDE("netapp/dhcp4_cli_asp.cfg");
 INCLUDE("netapp/tinet_dhcp4_cli.cfg");
 
@@ -65,4 +65,12 @@
 INCLUDE("netapp/resolver_asp.cfg");
 INCLUDE("netapp/tinet_resolver.cfg");
+
+/* NTPクライアント */
+#include "ntp_cli.h"
+//INCLUDE("ntp_cli.cfg");
+INCLUDE("tinet_ntp_cli.cfg");
+
+#include "net_misc.h"
+INCLUDE("net_misc.cfg");
 
 /* FatFs */
Index: /asp3_tinet_ecnl_rx/trunk/app7_buzzer/Debug/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app7_buzzer/Debug/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app7_buzzer/Debug/Makefile	(revision 340)
@@ -179,6 +179,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -187,5 +190,5 @@
 #
 APPLNAME = app7_buzzer
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app7_buzzer/DebugCitrus/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app7_buzzer/DebugCitrus/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app7_buzzer/DebugCitrus/Makefile	(revision 340)
@@ -179,6 +179,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -187,5 +190,5 @@
 #
 APPLNAME = app7_buzzer
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app7_buzzer/DebugEther/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app7_buzzer/DebugEther/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app7_buzzer/DebugEther/Makefile	(revision 340)
@@ -177,6 +177,9 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/echonet
 APPL_COBJS := echonet.o echonet_agent.o echonet_dbg.o echonet_fbs.o echonet_task.o echonet_udp_task.o echonet_udp6_task.o fbs_string.o
-APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o 
+APPLDIRS := $(APPLDIRS) $(SRCDIR)/$(TINETDIR)/netapp
+APPL_COBJS := $(APPL_COBJS) ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
 APPL_COBJS := $(APPL_COBJS) mbed_api.o netcmd.o fdtable.o io_stub.o socket_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
@@ -185,5 +188,5 @@
 #
 APPLNAME = app7_buzzer
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/echonet ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
Index: /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/echonet_main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/echonet_main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/echonet_main.c	(revision 340)
@@ -53,5 +53,5 @@
 
 /* TODO: メーカーコードを設定 */
-#define MAKER_CODE	0x00, 0x00, 0xB3	/* TOPPERSプロジェクト */
+#define MAKER_CODE	{ 0x00, 0x00, 0xB3 }	/* TOPPERSプロジェクト */
 
 /* ノードプロファイルオブジェクト */
Index: /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/main.c	(revision 340)
@@ -75,4 +75,5 @@
 #include "ntshell_main.h"
 #include <btstack/utils.h>
+#include "ntp_cli.h"
 
 ID ws_api_mailboxid = MAIN_DATAQUEUE;
@@ -301,4 +302,7 @@
 	}
 
+	if (link_up && up)
+		ntp_cli_execute();
+
 	ntshell_change_netif_link(link_up, up);
 
@@ -308,4 +312,5 @@
 extern int usrcmd_ping(int argc, char **argv);
 extern int usrcmd_dhcp4c(int argc, char **argv);
+extern int usrcmd_dnsc(int argc, char **argv);
 
 static const cmd_table_t cmdlist[] = {
@@ -317,6 +322,8 @@
 	{"mkdir", "Make directory", usrcmd_mkdir},
 	{"hexdump", "Hex dump", usrcmd_hexdump},
+	{"date", "print date and time", usrcmd_date},
 	{"ping", "ping", usrcmd_ping},
 	{"dhcpc", "DHCP Client rel/renew/info", usrcmd_dhcp4c},
+	{"dnsc", "DNS client", usrcmd_dnsc },
 	{"info", "This is a description text string for info command.", usrcmd_info},
 	{"exit", "Exit Natural Tiny Shell", usrcmd_exit},
Index: /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/main.cfg
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/main.cfg	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/main.cfg	(revision 340)
@@ -58,5 +58,5 @@
 /* DHCP クライアント */
 #include "netapp/dhcp4_cli.h"
-INCLUDE("netapp/dhcp4_cli_asp.cfg");
+//INCLUDE("netapp/dhcp4_cli_asp.cfg");
 INCLUDE("netapp/tinet_dhcp4_cli.cfg");
 
@@ -65,4 +65,12 @@
 INCLUDE("netapp/resolver_asp.cfg");
 INCLUDE("netapp/tinet_resolver.cfg");
+
+/* NTPクライアント */
+#include "ntp_cli.h"
+//INCLUDE("ntp_cli.cfg");
+INCLUDE("tinet_ntp_cli.cfg");
+
+#include "net_misc.h"
+INCLUDE("net_misc.cfg");
 
 /* FatFs */
Index: /asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/netapp/dhcp4_cli.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/netapp/dhcp4_cli.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/netapp/dhcp4_cli.c	(revision 340)
@@ -191,4 +191,20 @@
 #endif
 
+#ifdef SEM_DHCP4_CLI_TIMER
+#define DHCP4_CLI_TIMER_LOCK() do { syscall(wai_sem(SEM_DHCP4_CLI_TIMER)); } while(0)
+#define DHCP4_CLI_TIMER_UNLOCK() do { syscall(sig_sem(SEM_DHCP4_CLI_TIMER)); } while(0)
+#else
+#define DHCP4_CLI_TIMER_LOCK() do { } while(0)
+#define DHCP4_CLI_TIMER_UNLOCK() do { } while(0)
+#endif
+
+#ifdef SEM_DHCP4_CLI_READY
+#define DHCP4_CLI_READY_WAIT(ct) do { syscall(wai_sem(SEM_DHCP4_CLI_READY)); } while(0)
+#define DHCP4_CLI_READY_SIGNAL(ct) do { syscall(sig_sem(SEM_DHCP4_CLI_READY)); } while(0)
+#else
+#define DHCP4_CLI_READY_WAIT(ct) do { } while(0)
+#define DHCP4_CLI_READY_SIGNAL(ct) do { syscall(wup_tsk(ct->tskid)); } while(0)
+#endif
+
 /*
  *  dhcp4_cksum -- チェックサムの計算関数
@@ -919,8 +935,8 @@
 	int ix;
 
-	syscall(wai_sem(SEM_DHCP4_CLI_TIMER));
+	DHCP4_CLI_TIMER_LOCK();
 	for (ix = NUM_DHCP4C_TIMERS; ix -- > 0; )
 		ct->timers[ix] = 0;
-	syscall(sig_sem(SEM_DHCP4_CLI_TIMER));
+	DHCP4_CLI_TIMER_UNLOCK();
 	}
 
@@ -937,7 +953,7 @@
 
 	/* OFFER メッセージ受信タイムアウトを設定する。*/
-	syscall(wai_sem(SEM_DHCP4_CLI_TIMER));
+	DHCP4_CLI_TIMER_LOCK();
 	ct->timers[DHCP4C_TIMER_RCV_OFFER] = SYSTIM2TIMER(TMO_DHCP4C_OFFER);
-	syscall(sig_sem(SEM_DHCP4_CLI_TIMER));
+	DHCP4_CLI_TIMER_UNLOCK();
 
 	/* 送信先アドレスにローカルネットワークへのブロードキャストを設定する。*/
@@ -952,5 +968,5 @@
 	/* DISCOVER メッセージを送信する。*/
 	ct->flags |= DHCP4C_FLAG_TMOUT_SND_DISC;
-	syscall(sig_sem(SEM_DHCP4_CLI_READY));
+	DHCP4_CLI_READY_SIGNAL(ct);
 	}
 
@@ -979,9 +995,9 @@
 
 	/* EXPIRE、RENEW、REBIND タイマーを設定する。*/
-	syscall(wai_sem(SEM_DHCP4_CLI_TIMER));
+	DHCP4_CLI_TIMER_LOCK();
 	ct->timers[DHCP4C_TIMER_EXPIRE] = SYSTIM2TIMER(ct->expire);		/* EXPIRE      までの時間 */
 	ct->timers[DHCP4C_TIMER_REBIND] = SYSTIM2TIMER(ct->rebind);		/* REBIND（T2）までの時間 */
 	ct->timers[DHCP4C_TIMER_RENEW]  = SYSTIM2TIMER(ct->renew);		/* RENEW （T1）までの時間 */
-	syscall(sig_sem(SEM_DHCP4_CLI_TIMER));
+	DHCP4_CLI_TIMER_UNLOCK();
 
 	/* BOUND 状態に遷移する。*/
@@ -1006,7 +1022,7 @@
 	/* 遷移する状態が RENEW 以外では ACK/NAK メッセージ受信タイムアウトを設定する。*/
 	if (fsm != DHCP4_FSM_RENEW) { 
-		syscall(wai_sem(SEM_DHCP4_CLI_TIMER));
+		DHCP4_CLI_TIMER_LOCK();
 		ct->timers[DHCP4C_TIMER_RCV_ACK] = SYSTIM2TIMER(TMO_DHCP4C_ACK);
-		syscall(sig_sem(SEM_DHCP4_CLI_TIMER));
+		DHCP4_CLI_TIMER_UNLOCK();
 		}
 
@@ -1029,5 +1045,5 @@
 	/* REQUEST メッセージを送信する。*/
 	ct->flags |= DHCP4C_FLAG_TMOUT_SND_REQ;
-	syscall(sig_sem(SEM_DHCP4_CLI_READY));
+	DHCP4_CLI_READY_SIGNAL(ct);
 	}
 
@@ -1055,5 +1071,5 @@
 	/* RELEASE メッセージを送信する。*/
 	ct->flags |= DHCP4C_FLAG_TMOUT_SND_REL;
-	syscall(sig_sem(SEM_DHCP4_CLI_READY));
+	DHCP4_CLI_READY_SIGNAL(ct);
 	}
 
@@ -1349,7 +1365,7 @@
 
 		/* REQUEST メッセージ送信タイマーを停止する。*/
-		syscall(wai_sem(SEM_DHCP4_CLI_TIMER));
+		DHCP4_CLI_TIMER_LOCK();
 		ct->timers[DHCP4C_TIMER_SND_REQ] = 0;
-		syscall(sig_sem(SEM_DHCP4_CLI_TIMER));
+		DHCP4_CLI_TIMER_UNLOCK();
 
 		/*
@@ -1399,7 +1415,7 @@
 
 		/* ACK/NAK メッセージ受信タイマーを停止する。*/
-		syscall(wai_sem(SEM_DHCP4_CLI_TIMER));
+		DHCP4_CLI_TIMER_LOCK();
 		ct->timers[DHCP4C_TIMER_RCV_ACK] = 0;
-		syscall(sig_sem(SEM_DHCP4_CLI_TIMER));
+		DHCP4_CLI_TIMER_UNLOCK();
 
 		/*
@@ -1475,7 +1491,7 @@
 
 	/* 再送信タイムアウトを設定する。*/
-	syscall(wai_sem(SEM_DHCP4_CLI_TIMER));
+	DHCP4_CLI_TIMER_LOCK();
 	ct->timers[DHCP4C_TIMER_SND_REQ] = SYSTIM2TIMER(ct->interval);
-	syscall(sig_sem(SEM_DHCP4_CLI_TIMER));
+	DHCP4_CLI_TIMER_UNLOCK();
 	}
 
@@ -1511,5 +1527,5 @@
 
 	/* メッセージ送信待ちを行う。*/
-	syscall(wai_sem(SEM_DHCP4_CLI_READY));
+	DHCP4_CLI_READY_WAIT(ct);
 
 	/* SLEEP 状態に遷移する。*/
@@ -1529,7 +1545,7 @@
 
 		/* DISCOVER メッセージ送信タイマーを停止する。*/
-		syscall(wai_sem(SEM_DHCP4_CLI_TIMER));
+		DHCP4_CLI_TIMER_LOCK();
 		ct->timers[DHCP4C_TIMER_SND_DISC] = 0;
-		syscall(sig_sem(SEM_DHCP4_CLI_TIMER));
+		DHCP4_CLI_TIMER_UNLOCK();
 
 		/* REQUEST メッセージを送信して REQUEST 状態に遷移する。*/
@@ -1559,7 +1575,7 @@
 
 		/* OFFER メッセージ受信タイマーを停止する。*/
-		syscall(wai_sem(SEM_DHCP4_CLI_TIMER));
+		DHCP4_CLI_TIMER_LOCK();
 		ct->timers[DHCP4C_TIMER_RCV_OFFER] = 0;
-		syscall(sig_sem(SEM_DHCP4_CLI_TIMER));
+		DHCP4_CLI_TIMER_UNLOCK();
 
 		/* REQUEST メッセージを送信して REQUEST 状態に遷移する。*/
@@ -1614,8 +1630,10 @@
 
 	/* 再送信タイムアウトを設定する。*/
-	syscall(wai_sem(SEM_DHCP4_CLI_TIMER));
+	DHCP4_CLI_TIMER_LOCK();
 	ct->timers[DHCP4C_TIMER_SND_DISC] = SYSTIM2TIMER(ct->interval);
-	syscall(sig_sem(SEM_DHCP4_CLI_TIMER));
-	}
+	DHCP4_CLI_TIMER_UNLOCK();
+	}
+
+#ifdef DHCP4_CLI_TASK
 
 /*
@@ -1628,5 +1646,5 @@
 	int ix;
 
-	syscall(wai_sem(SEM_DHCP4_CLI_TIMER));
+	DHCP4_CLI_TIMER_LOCK();
 	for (ix = NUM_DHCP4C_TIMERS; ix -- > 0; ) {
 		if (ct->timers[ix] != 0) {
@@ -1634,13 +1652,15 @@
 			if (ct->timers[ix] == 0) {
 				ct->flags = (ct->flags & ~DHCP4C_FLAG_TMOUT_MASK) | DHCP4C_FLAG_TMOUT_TIMER | ix;
-				syscall(sig_sem(SEM_DHCP4_CLI_READY));
+				DHCP4_CLI_READY_SIGNAL(ct);
 				}
 			}
 		}
-	syscall(sig_sem(SEM_DHCP4_CLI_TIMER));
+	DHCP4_CLI_TIMER_UNLOCK();
 
 	/* 1秒毎にタイムアウトする。*/
 	timeout((callout_func)dhcpc_timer, ct, NET_TIMER_HZ);
 	}
+
+#endif
 
 /*
@@ -1748,4 +1768,6 @@
 	}
 
+#ifdef DHCP4_CLI_TASK
+
 /*
  *  dispatch_event -- イベント毎の処理
@@ -1760,5 +1782,5 @@
 
 		/* メッセージの受信とタイムアウトを待つ。*/
-		syscall(wai_sem(SEM_DHCP4_CLI_READY));
+		DHCP4_CLI_READY_WAIT(ct);
 
 		if (ct->flags & DHCP4C_FLAG_RCV_MSG) {
@@ -1778,4 +1800,6 @@
 	}
 
+#endif
+
 /*
  *  init_context -- DHCP クライアントコンテキスト構造体を初期化する。
@@ -1783,7 +1807,8 @@
 
 static void
-init_context (T_DHCP4_CLI_CONTEXT *ct, ID cepid)
+init_context (T_DHCP4_CLI_CONTEXT *ct, ID tskid, ID cepid)
 {
   	memset(ct, 0, sizeof(*ct));
+	ct->tskid	= tskid;
 	ct->cepid	= cepid;
 	ct->sc		= IF_ETHER_NIC_GET_SOFTC();
@@ -1880,5 +1905,7 @@
 
 		/* SLEEP を解除する。*/
-		wup_tsk(DHCP4_CLI_TASK);
+		context.fsm = DHCP4_FSM_WAKE;
+		context.timer = 0;
+		wup_tsk(context.tskid);
 		return E_OK;
 		}
@@ -1970,8 +1997,10 @@
 				}
 			}
-		syscall(sig_sem(SEM_DHCP4_CLI_READY));
+		DHCP4_CLI_READY_SIGNAL((&context));
 		}
 	return E_OK;
 	}
+
+#ifdef DHCP4_CLI_TASK
 
 /*
@@ -1993,5 +2022,5 @@
 
 	/* DHCP クライアントコンテキスト構造体を初期化する。*/
-	init_context(ct, (ID)exinf);
+	init_context(ct, tskid, (ID)exinf);
 	ct->fsm = DHCP4_FSM_SLEEP;
 
@@ -2037,3 +2066,107 @@
 	}
 
+#else
+
+T_DHCP4_CLI_CONTEXT *
+dhcp4_cli_initialize(ID tskid, ID cepid)
+{
+	T_DHCP4_CLI_CONTEXT *ct = &context;
+	/* DHCP クライアントコンテキスト構造体を初期化する。*/
+	init_context(ct, tskid, cepid);
+	ct->fsm = DHCP4_FSM_SLEEP;
+	ct->timer = TMO_FEVR;
+	return ct;
+	}
+
+int
+dhcp4_cli_get_timer(T_DHCP4_CLI_CONTEXT *ct)
+{
+	if (ct->fsm == DHCP4_FSM_SLEEP)
+		return TMO_FEVR;
+
+	return ct->timer;
+	}
+
+void
+dhcp4_cli_progress(T_DHCP4_CLI_CONTEXT *ct, int elapse)
+{
+	int ix;
+
+	if ((ct->fsm == DHCP4_FSM_SLEEP) || (ct->timer == TMO_FEVR))
+		return;
+
+	ct->timer -= elapse;
+	if (ct->timer > 0)
+		return;
+
+	/* 1秒毎にタイムアウトするようにタイマーを設定する。*/
+	ct->timer = 1000 * 1000;
+
+	for (ix = NUM_DHCP4C_TIMERS; ix-- > 0; ) {
+		if (ct->timers[ix] != 0) {
+			ct->timers[ix] --;
+			if (ct->timers[ix] <= 0) {
+				ct->timers[ix] = 0;
+				ct->flags = (ct->flags & ~DHCP4C_FLAG_TMOUT_MASK) | DHCP4C_FLAG_TMOUT_TIMER | ix;
+				DHCP4_CLI_READY_SIGNAL(ct);
+				}
+			}
+		}
+	}
+
+void
+dhcp4_cli_wakeup(T_DHCP4_CLI_CONTEXT *ct)
+{
+	if (ct->fsm == DHCP4_FSM_WAKE) {
+		ct->flags = 0;
+		ct->error = E_OK;
+
+		/* メッセージ構造体を初期化する。*/
+		if ((ct->error = init_cli_msg(ct)) != E_OK)
+			return;
+
+		ct->timer = 1000 * 1000;
+
+		/* SELECT 状態に遷移する。*/
+		start_select(ct);
+		}
+
+	if (ct->flags & DHCP4C_FLAG_RCV_MSG) {
+		while (ct->val_lst != NULL) {
+			ct->error = eval_rcv_msg(ct);
+			}
+		ct->flags &= ~DHCP4C_FLAG_RCV_MSG;
+		}
+	}
+
+void
+dhcp4_cli_timeout(T_DHCP4_CLI_CONTEXT *ct)
+{
+	if (ct->flags & DHCP4C_FLAG_TMOUT_MASK)
+		ct->error = dispatch_timeout(ct);
+
+	if (ct->error != E_OK || ct->fsm == DHCP4_FSM_SLEEP) {
+		/* 全ての TIMER をキャンセルする。*/
+		cancel_all_timers(ct);
+		ct->timer = TMO_FEVR;
+
+		/* メッセージ構造体を解放する。*/
+		rel_cli_msg(ct);
+
+		/* リースを解放後、再取得が指定されていなければ休止する。*/
+		if (!(ct->flags & DHCP4C_FLAG_RENEW)) {
+
+			/* 休止する。*/
+			if (ct->error == E_OK)
+				syslog(LOG_NOTICE, "[DHCP4C] lease released, go to sleep.");
+			else {
+				syslog(LOG_NOTICE, "[DHCP4C] server not available, go to sleep, error: %s.", itron_strerror(ct->error));
+				ct->error = E_OK;
+				ct->fsm = DHCP4_FSM_SLEEP;
+				}
+			}
+		}
+	}
+
+#endif /* DHCP4_CLI_TASK */
 #endif	/* of #ifdef DHCP4_CLI_CFG */
Index: /asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/netapp/dhcp4_cli_var.h
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/netapp/dhcp4_cli_var.h	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/netapp/dhcp4_cli_var.h	(revision 340)
@@ -164,4 +164,5 @@
 	RELTIM		interval;	/* 送信間隔			*/
 	ER_UINT		error;		/* エラー・データ長		*/
+	ID			tskid;		/* タスクID */
 	ID		cepid;		/* CEP ID			*/
 	uint32_t	xid;		/* トランザクション ID		*/
@@ -170,4 +171,5 @@
 	uint16_t	secs;		/* seconds since boot began	*/
 	uint8_t		fsm;		/* 現在の状態			*/
+	int timer;
 	} T_DHCP4_CLI_CONTEXT;
 
@@ -184,4 +186,5 @@
 #define DHCP4_FSM_REL_INFO	11	/* DHCPv4 の RFC2131 には無い。*/
 #define DHCP4_FSM_SLEEP		12	/* DHCPv4 の RFC2131 には無い。*/
+#define DHCP4_FSM_WAKE		13	/* DHCPv4 の RFC2131 には無い。*/
 
 /* flag の定義 */
Index: /asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/netinet/ip_igmp.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/netinet/ip_igmp.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/netinet/ip_igmp.c	(revision 340)
@@ -297,5 +297,5 @@
 	igmph->type = IGMP_MEMBERSHIP_REPORT_V2;
 	igmph->time = 0;
-	igmph->addr = dst;
+	igmph->addr = htonl(dst);
 
 	/* 4 オクテット境界のデータ長 */
Index: /asp3_tinet_ecnl_rx/trunk/bnep_bridge/Debug/Makefile
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/bnep_bridge/Debug/Makefile	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/bnep_bridge/Debug/Makefile	(revision 340)
@@ -178,13 +178,14 @@
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
 
+APPLDIRS := $(APPLDIRS) ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src
+APPL_COBJS := $(APPL_COBJS) ntshell_main.o mbed_api.o fdtable.o io_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
+
 #
 #  アプリケーションプログラムに関する定義
 #
 APPLNAME = bnep_bridge
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS := $(APPLDIRS) ../src
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
-
-APPL_COBJS := $(APPL_COBJS) ntshell_main.o mbed_api.o fdtable.o io_stub.o ffarch.o diskio.o ff.o mmc_rspi.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
 
 APPL_DIRS := $(APPLDIRS) $(SRCDIR)/library
Index: /asp3_tinet_ecnl_rx/trunk/musl-1.1.18/include/bits/alltypes.h
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/musl-1.1.18/include/bits/alltypes.h	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/musl-1.1.18/include/bits/alltypes.h	(revision 340)
@@ -20,8 +20,13 @@
 #define perror musl_perror
 #define strnlen musl_strnlen
+#define strftime musl_strftime
+#define asctime musl_asctime
+#define tzset musl_tzset
+#define clock musl_clock
 #endif
 #ifdef _MSC_VER
 #define __builtin_va_list char *
 #define __NEED_va_list
+#define restrict __restrict
 #endif
 
Index: /asp3_tinet_ecnl_rx/trunk/musl-1.1.18/include/time.h
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/musl-1.1.18/include/time.h	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/musl-1.1.18/include/time.h	(revision 340)
@@ -61,5 +61,7 @@
 int timespec_get(struct timespec *, int);
 
+#ifndef CLOCKS_PER_SEC
 #define CLOCKS_PER_SEC 1000000L
+#endif // CLOCKS_PER_SEC
 
 #define TIME_UTC 1
Index: /asp3_tinet_ecnl_rx/trunk/musl-1.1.18/src/time/localtime_r.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/musl-1.1.18/src/time/localtime_r.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/musl-1.1.18/src/time/localtime_r.c	(revision 340)
@@ -19,3 +19,10 @@
 }
 
+#ifndef __c2__
 weak_alias(__localtime_r, localtime_r);
+#else
+struct tm *localtime_r(const time_t *restrict t, struct tm *restrict tm)
+{
+	return __localtime_r(t, tm);
+}
+#endif
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/ntshell/usrcmd.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/ntshell/usrcmd.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/ntshell/usrcmd.c	(revision 340)
@@ -790,4 +790,30 @@
 }
 
+int usrcmd_date(int argc, char **argv)
+{
+	int ret;
+	struct timespec tp;
+	char buf[30];
+
+	ret = shell_clock_gettime(CLOCK_REALTIME, &tp);
+	if (ret != 0) {
+		ntstdio_printf(&ntstdio, "clock_gettime error %d", ret);
+		return 0;
+	}
+
+	memset(buf, 0, sizeof(buf));
+	if (ctime_r(&tp.tv_sec, buf) == NULL) {
+		ntstdio_printf(&ntstdio, "ctime_r error");
+		return 0;
+	}
+
+	/* 改行コードの削除 */
+	ret = ntlibc_strlen(buf);
+	buf[ret - 1] = '\0';
+
+	ntstdio_printf(&ntstdio, "%s .%09u\n", buf, tp.tv_nsec);
+	return 0;
+}
+
 int usrcmd_info(int argc, char **argv)
 {
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/ntshell/usrcmd.h
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/ntshell/usrcmd.h	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/ntshell/usrcmd.h	(revision 340)
@@ -50,4 +50,5 @@
 int usrcmd_mkdir(int argc, char **argv);
 int usrcmd_hexdump(int argc, char **argv);
+int usrcmd_date(int argc, char **argv);
 
 int usrcmd_help(int argc, char **argv);
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/src/net_misc.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/src/net_misc.c	(revision 340)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/src/net_misc.c	(revision 340)
@@ -0,0 +1,145 @@
+/*
+ *  TOPPERS ECHONET Lite Communication Middleware
+ * 
+ *  Copyright (C) 2018 Cores Co., Ltd. Japan
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  @(#) $Id: net_misc.c 1497 2018-04-13 00:04:30Z coas-nagasima $
+ */
+
+#include <kernel.h>
+#include <sil.h>
+#include <t_syslog.h>
+#include <t_stdlib.h>
+
+#include <tinet_defs.h>
+#include <tinet_config.h>
+
+#include <net/if.h>
+#include <net/ethernet.h>
+
+#include <net/net.h>
+#include <net/net_endian.h>
+#include <net/net_var.h>
+#include <net/net_timer.h>
+
+#include <netinet/in.h>
+#include <netinet/in_var.h>
+
+#include "netapp/dhcp4_cli.h"
+#include "netapp/dhcp4_cli_var.h"
+#include "ntp_cli.h"
+#include "kernel_cfg.h"
+#include "tinet_cfg.h"
+
+T_DHCP4_CLI_CONTEXT *dhcp4_cli_initialize(ID tskid, ID cepid);
+int dhcp4_cli_get_timer(T_DHCP4_CLI_CONTEXT *ct);
+void dhcp4_cli_progress(T_DHCP4_CLI_CONTEXT *ct, int elapse);
+void dhcp4_cli_wakeup(T_DHCP4_CLI_CONTEXT *ct);
+void dhcp4_cli_timeout(T_DHCP4_CLI_CONTEXT *ct);
+
+int net_misc_get_timer(T_DHCP4_CLI_CONTEXT *ct, T_NTP_CLI_CONTEXT *nc)
+{
+	int timer = dhcp4_cli_get_timer(ct);
+
+	if ((nc->timer != TMO_FEVR) && ((timer == TMO_FEVR) || (timer > nc->timer))) {
+		timer = nc->timer;
+	}
+
+	return timer;
+}
+
+extern T_NTP_CLI_CONTEXT ntp_cli;
+
+/*
+ *  DHCP, NTP クライアント タスク
+ */
+
+void
+net_misc_task (intptr_t exinf)
+{
+	T_DHCP4_CLI_CONTEXT *ct;
+	T_NTP_CLI_CONTEXT *nc = &ntp_cli;
+	ER		error = E_OK, ret;
+	SYSTIM		prev, time;
+	int timer;
+
+	get_tid(&nc->tskid);
+	syslog(LOG_NOTICE, "[NET MISC:%d,%d] started.", nc->tskid, (ID)exinf);
+
+	/* 初期化 */
+	ct = dhcp4_cli_initialize(nc->tskid, UDP4_DHCP_CLI_CEPID);
+	ntp_cli_initialize(nc, NTP_CLI_CEPID);
+
+	ret = get_tim(&time);
+	if (ret != E_OK) {
+		syslog(LOG_NOTICE, "[NET MISC,%d] get_tim error: %7lu,%s",
+			nc->cepid, time / SYSTIM_HZ, itron_strerror(ret));
+		return;
+	}
+
+	while (true) {
+		prev = time;
+
+		/* タイマー取得 */
+		timer = net_misc_get_timer(ct, nc);
+
+		/* 待ち */
+		error = tslp_tsk(timer);
+		if ((error != E_OK) && (error != E_TMOUT)) {
+			syslog(LOG_NOTICE, "[NET MISC,%d] tslp_tsk error: %s %d",
+				nc->cepid, itron_strerror(error), timer);
+			break;
+		}
+
+		ret = get_tim(&time);
+		if (ret != E_OK) {
+			syslog(LOG_NOTICE, "[NET MISC,%d] get_tim error: %s",
+				nc->cepid, itron_strerror(ret));
+			break;
+		}
+
+		/* 時間経過 */
+		int elapse = time - prev;
+		dhcp4_cli_progress(ct, elapse);
+		ntp_cli_progress(nc, elapse);
+
+		/* 起こされた場合 */
+		if (error == E_OK) {
+			dhcp4_cli_wakeup(ct);
+			ntp_cli_wakeup(nc);
+		}
+
+		/* タイムアウト処理 */
+		dhcp4_cli_timeout(ct);
+		ntp_cli_timeout(nc);
+	}
+}
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/src/net_misc.cfg
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/src/net_misc.cfg	(revision 340)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/src/net_misc.cfg	(revision 340)
@@ -0,0 +1,65 @@
+/*
+ *  TOPPERS ECHONET Lite Communication Middleware
+ * 
+ *  Copyright (C) 2018 Cores Co., Ltd. Japan
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  @(#) $Id: net_misc.cfg 1497 2018-04-13 00:04:30Z coas-nagasima $
+ */
+
+/*
+ *  DHCP, NTP クライアントのシステムコンフィギュレーションファイル
+ */
+
+/* セマフォ */
+
+CRE_SEM(SEM_DHCP4_CLI_LOCK,	{ TA_TPRI, 1, 1 });
+
+/* 送受信バッファ */
+
+CRE_MPF(MPF_DHCP4_CLI_MSG, {
+	TA_TFIFO,
+	NUM_MPF_DHCP4_CLI_MSG,
+	sizeof(T_DHCP4_CLI_MSG),
+	NULL,
+	NULL
+	});
+
+/* タスク */
+
+CRE_TSK(NET_MISC_TASK, {
+	TA_HLNG|TA_ACT,
+	0,
+	net_misc_task,
+	NET_MISC_MAIN_PRIORITY,
+	NET_MISC_STACK_SIZE,
+	NULL
+	});
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/src/net_misc.h
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/src/net_misc.h	(revision 340)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/src/net_misc.h	(revision 340)
@@ -0,0 +1,53 @@
+/*
+ *  TOPPERS ECHONET Lite Communication Middleware
+ * 
+ *  Copyright (C) 2018 Cores Co., Ltd. Japan
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  @(#) $Id: net_misc.h 1497 2018-04-13 00:04:30Z coas-nagasima $
+ */
+
+#ifndef _NET_MISC_H_
+#define _NET_MISC_H_
+
+/* スタックサイズ */
+
+#define NET_MISC_STACK_SIZE	1024		/* NTP クライアントタスク（IPv4）のスタックサイズ	*/
+
+/* 優先度 */
+
+#define NET_MISC_MAIN_PRIORITY	5		/* NTP クライアントタスク（IPv4）の優先度		*/
+
+/* タスク */
+
+extern void	net_misc_task(intptr_t exinf);
+
+#endif	/* of #ifndef _NET_MISC_H_ */
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/src/netcmd.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/src/netcmd.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/src/netcmd.c	(revision 340)
@@ -60,4 +60,5 @@
 #include "core/ntlibc.h"
 #include "util/ntstdio.h"
+#include "ntp_cli.h"
 #include "kernel_cfg.h"
 
@@ -469,2 +470,8 @@
 	return 0;
 }
+
+int usrcmd_ntpc(int argc, char **argv)
+{
+	ntp_cli_execute();
+	return 0;
+}
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/src/ntp_cli.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/src/ntp_cli.c	(revision 340)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/src/ntp_cli.c	(revision 340)
@@ -0,0 +1,563 @@
+/*
+ *  TOPPERS ECHONET Lite Communication Middleware
+ * 
+ *  Copyright (C) 2018 Cores Co., Ltd. Japan
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  @(#) $Id: ntp_cli.c 1496 2018-04-12 11:59:40Z coas-nagasima $
+ */
+
+/* 
+ *  NTP クライアント
+ */
+
+#include <string.h>
+#include <string.h>
+#include <time.h>
+
+#if defined(TARGET_KERNEL_ASP)
+
+#include <kernel.h>
+#include <sil.h>
+#include <t_syslog.h>
+#include "kernel_cfg.h"
+
+#endif	/* of #if defined(TARGET_KERNEL_ASP) */
+
+#if defined(TARGET_KERNEL_JSP)
+
+#include <t_services.h>
+#include "kernel_id.h"
+#include "tinet_id.h"
+
+#endif	/* of #if defined(TARGET_KERNEL_JSP) */
+
+#include <netinet/in.h>
+#include <netinet/in_itron.h>
+
+#include <netapp/netapp.h>
+#include <netapp/netapp_var.h>
+#include "ntp_cli.h"
+
+/* NTP サーバのポート番号 */
+
+#define NTP_SRV_PORTNO		UINT_C(123)
+
+/* NTP サーバのURL */
+
+#define NTP_SRV_URL		"ntp.nict.jp"
+
+/* 送信間隔 */
+
+#define SLP_ITV		(60*SYSTIM_HZ)
+
+/* 関数 */
+
+void ntp_cli_update_time(T_NTP_CLI_CONTEXT *nc);
+ER ntp_cli_time_synchronization(T_NTP_CLI_CONTEXT *nc, ntp_mode_t mode);
+void ntp_cli_read_time(T_NTP_CLI_CONTEXT *nc, struct timespec *tp);
+void ntp_cli_write_time(T_NTP_CLI_CONTEXT *nc, struct timespec *tp);
+void ntp_cli_read_data(T_NTP_CLI_CONTEXT *nc);
+
+/*
+ *  全域変数
+ */
+
+T_NTP_CLI_CONTEXT ntp_cli;
+
+/* UNIX:1970/1/1 - NTP:1900/1/1 */
+#define TIME_OFS (25567ll * 24 * 60 * 60)
+
+void set_systime_to_ntptime(struct timespec *tp, T_NTP_TIMESTAMP *timestamp)
+{
+	timestamp->integer = htonl((uint32_t)(tp->tv_sec + TIME_OFS));
+	timestamp->fraction = htonl((((unsigned long long)tp->tv_nsec) << 32) / 1000000000ll);
+}
+
+void set_ntptime_to_systime(struct timespec *tp, T_NTP_TIMESTAMP *timestamp)
+{
+	tp->tv_sec = ntohl(timestamp->integer) - TIME_OFS;
+	tp->tv_nsec = ((unsigned long long)(ntohl(timestamp->fraction) * 1000000000ll)) >> 32;
+}
+
+void add_timestamp(T_NTP_TIMESTAMP *dst, T_NTP_TIMESTAMP *a, T_NTP_TIMESTAMP *b)
+{
+	uint32_t ai = ntohl(a->integer);
+	uint32_t af = ntohl(a->fraction);
+	uint32_t bi = ntohl(b->integer);
+	uint32_t bf = ntohl(b->fraction);
+	uint32_t f = af + bf;
+	uint32_t o = ((f < af) || (f < bf)) ? 1u : 0;
+	uint32_t i = ai + bi + o;
+	dst->integer = htonl(i);
+	dst->fraction = htonl(f);
+}
+
+void sub_timestamp(T_NTP_TIMESTAMP *dst, T_NTP_TIMESTAMP *a, T_NTP_TIMESTAMP *b)
+{
+	uint32_t ai = ntohl(a->integer);
+	uint32_t af = ntohl(a->fraction);
+	uint32_t bi = ntohl(b->integer);
+	uint32_t bf = ntohl(b->fraction);
+	uint32_t o = (af < bf) ? 1u : 0u;
+	uint32_t f = af - bf;
+	uint32_t i = ai - bi - o;
+	dst->integer = htonl(i);
+	dst->fraction = htonl(f);
+}
+
+void div2_timestamp(T_NTP_TIMESTAMP *a)
+{
+	uint32_t ai = ntohl(a->integer);
+	uint32_t af = ntohl(a->fraction);
+
+	if ((ai & 1) != 0) {
+		ai >>= 1;
+		af >>= 1;
+		af |= 0x80000000u;
+	}
+	else {
+		ai >>= 1;
+		af >>= 1;
+	}
+
+	a->integer = htonl(ai);
+	a->fraction = htonl(af);
+}
+
+#define NTP_POLL_ASYNC 10		// 1024秒毎に時刻問い合わせ
+#define NTP_POLL_NORMAL 16		// 65536秒毎に時刻問い合わせ
+
+void ntp_cli_initialize(T_NTP_CLI_CONTEXT *nc, ID cepid)
+{
+	nc->cepid = cepid;
+	nc->state = NTP_CLI_STATE_ASYNC;
+	nc->timer = TMO_FEVR;
+	nc->snd_rmt.portno = NTP_SRV_PORTNO;
+	nc->snd_rmt.ipaddr = IPV4_ADDRANY;
+	nc->rcv_rmt.portno = 0;
+	nc->rcv_rmt.ipaddr = IPV4_ADDRANY;
+}
+
+void ntp_cli_execute()
+{
+	ntp_cli.exe_flag = 1;
+	syscall(wup_tsk(ntp_cli.tskid));
+}
+
+void ntp_cli_wakeup(T_NTP_CLI_CONTEXT *nc)
+{
+	int rcv_flag = nc->rcv_flag;
+	nc->rcv_flag = 0;
+
+	if (rcv_flag > 0) {
+		ntp_cli_read_data(nc);
+		return;
+	}
+
+	if (nc->exe_flag != 0) {
+		nc->exe_flag = 0;
+
+		nc->state = NTP_CLI_STATE_ASYNC;
+		nc->timer = 0;
+	}
+}
+
+void ntp_cli_read_data(T_NTP_CLI_CONTEXT *nc)
+{
+	struct timespec tp;
+	T_NTP_MSG *ntp = &nc->ntp_msg;
+
+	// NTP時刻応答の場合
+	if ((ntp->mode == NTP_MODE_SERVER) || (ntp->mode == NTP_MODE_BROADCAST)) {
+		switch (nc->state) {
+		case NTP_CLI_STATE_RESOLVE_ADDR:
+		case NTP_CLI_STATE_ASYNC:
+			break;
+		case NTP_CLI_STATE_REQUEST:
+			// サーバーからの応答時刻を取得
+			memcpy(&nc->receive_timestamp, &ntp->receive_timestamp, sizeof(nc->receive_timestamp));
+			memcpy(&nc->transmit_timestamp, &ntp->transmit_timestamp, sizeof(nc->transmit_timestamp));
+
+			// 現在時刻取得
+			ntp_cli_read_time(nc, &tp);
+
+			// NTP参照時刻に現在時刻を設定
+			set_systime_to_ntptime(&tp, &nc->recv_resp_timestamp);
+
+			// 時刻を更新
+			ntp_cli_update_time(nc);
+
+			nc->state = NTP_CLI_STATE_SYNC;
+			nc->poll = NTP_POLL_NORMAL;
+			nc->timer = (1 << nc->poll) * 1000 * 1000;
+			break;
+		case NTP_CLI_STATE_SYNC:
+			break;
+		}
+	}
+	// NTP時刻要求の場合
+	else if (ntp->mode == NTP_MODE_CLIENT) {
+		// 現在時刻取得
+		ntp_cli_read_time(nc, &tp);
+
+		// NTP受信・送信時刻に現在時刻を設定
+		set_systime_to_ntptime(&tp, &nc->receive_timestamp);
+		set_systime_to_ntptime(&tp, &nc->transmit_timestamp);
+
+		// NTPパケット送信
+		ntp_cli_time_synchronization(nc, NTP_MODE_SERVER);
+	}
+}
+
+void ntp_cli_update_time(T_NTP_CLI_CONTEXT *nc)
+{
+	struct timespec tp;
+	T_NTP_TIMESTAMP dt1, dt2, ofs;
+
+	sub_timestamp(&dt1, &nc->receive_timestamp, &nc->originate_timestamp);
+	sub_timestamp(&dt2, &nc->recv_resp_timestamp, &nc->transmit_timestamp);
+	sub_timestamp(&ofs, &dt1, &dt2);
+	div2_timestamp(&ofs);
+
+	// 差が大きい場合はサーバーの送信時間を設定
+	if (ntohl(ofs.integer) > 2) {
+		memcpy(&nc->reference_timestamp, &nc->transmit_timestamp, sizeof(nc->transmit_timestamp));
+	}
+	else {
+		add_timestamp(&nc->reference_timestamp, &nc->recv_resp_timestamp, &ofs);
+	}
+
+	set_ntptime_to_systime(&tp, &nc->reference_timestamp);
+
+	ntp_cli_write_time(nc, &tp);
+
+	nc->buf[0] = '\0';
+#ifndef _MSC_VER
+	if (ctime_r(&tp.tv_sec, nc->buf) != NULL)
+#else
+	if (ctime_s(nc->buf, sizeof(nc->buf), &tp.tv_sec) == 0)
+#endif
+	{
+		/* 改行コードの削除 */
+		int len = strnlen(nc->buf, sizeof(nc->buf) - 1);
+		nc->buf[len - 1] = '\0';
+	}
+	else {
+		nc->buf[0] = '\0';
+	}
+
+	syslog(LOG_NOTICE, "[NTP CLI,%d] recv time: %s .%09u",
+		nc->cepid, nc->buf, tp.tv_nsec);
+}
+
+int ntp_cli_get_timer(T_NTP_CLI_CONTEXT *nc)
+{
+	return nc->timer;
+}
+
+void ntp_cli_progress(T_NTP_CLI_CONTEXT *nc, TMO elapse)
+{
+	if (nc->timer <= 0)
+		return;
+
+	nc->timer -= elapse;
+	if (nc->timer < 0)
+		nc->timer = 0;
+}
+
+void ntp_cli_timeout(T_NTP_CLI_CONTEXT *nc)
+{
+	struct timespec tp;
+	char *line;
+
+	if (nc->timer != 0)
+		return;
+
+	switch (nc->state) {
+	case NTP_CLI_STATE_ASYNC:
+#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4)
+		line = lookup_ipaddr(&nc->ipaddr6, NTP_SRV_URL, API_PROTO_IPV4);
+		if (line == NULL || !in6_is_addr_ipv4mapped(&nc->ipaddr6)) {
+			syslog(LOG_NOTICE, "[NTP CLI,%d] sleep %d.%03u[s], unknown host.",
+				nc->cepid, SLP_ITV / SYSTIM_HZ, SLP_ITV % SYSTIM_HZ);
+			nc->timer = SLP_ITV;
+			break;
+		}
+		nc->snd_rmt.ipaddr = ntohl(nc->ipaddr6.s6_addr32[3]);
+#else	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) */
+		if ((line = lookup_ipaddr(&nc->snd_rmt.ipaddr, NTP_SRV_URL, DEFAULT_API_PROTO)) == NULL) {
+			syslog(LOG_NOTICE, "[NTP CLI,%d] sleep %d.%03u[s], unknown host.",
+				nc->cepid, SLP_ITV / SYSTIM_HZ, SLP_ITV % SYSTIM_HZ);
+			nc->timer = SLP_ITV;
+			break;
+		}
+#endif	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) */
+		nc->state = NTP_CLI_STATE_RESOLVE_ADDR;
+		nc->timer = 1000;
+		/* through */
+	case NTP_CLI_STATE_RESOLVE_ADDR:
+		// 現在時刻取得
+		ntp_cli_read_time(nc, &tp);
+
+		// NTP開始時刻に現在時刻を設定
+		set_systime_to_ntptime(&tp, &nc->originate_timestamp);
+		memset(&nc->receive_timestamp, 0, sizeof(nc->receive_timestamp));
+		memset(&nc->transmit_timestamp, 0, sizeof(nc->transmit_timestamp));
+
+		// NTPパケット送信
+		ntp_cli_time_synchronization(nc, NTP_MODE_CLIENT);
+
+		// NTP応答待ちに遷移、500msでリトライ
+		nc->retry = 0;
+		nc->state = NTP_CLI_STATE_REQUEST;
+		nc->timer = 500 * 1000;
+		break;
+	case NTP_CLI_STATE_REQUEST:
+		nc->retry++;
+		if (nc->retry > 3) {
+			nc->state = NTP_CLI_STATE_ASYNC;
+			nc->poll = NTP_POLL_ASYNC;
+			nc->timer = (1 << nc->poll) * 1000 * 1000;  // 1024秒後に時刻同期
+			break;
+		}
+		// 現在時刻取得
+		ntp_cli_read_time(nc, &tp);
+
+		// NTP開始時刻に現在時刻を設定
+		set_systime_to_ntptime(&tp, &nc->originate_timestamp);
+		memset(&nc->receive_timestamp, 0, sizeof(nc->receive_timestamp));
+		memset(&nc->transmit_timestamp, 0, sizeof(nc->transmit_timestamp));
+
+		// NTPパケット送信
+		ntp_cli_time_synchronization(nc, NTP_MODE_CLIENT);
+
+		// NTP応答待ちに遷移、500msでリトライ
+		nc->state = NTP_CLI_STATE_REQUEST;
+		nc->timer = 500 * 1000;
+		break;
+	case NTP_CLI_STATE_SYNC:
+		// 現在時刻取得
+		ntp_cli_read_time(nc, &tp);
+
+		// NTP開始時刻に現在時刻を設定
+		set_systime_to_ntptime(&tp, &nc->originate_timestamp);
+		memset(&nc->receive_timestamp, 0, sizeof(nc->receive_timestamp));
+		memset(&nc->transmit_timestamp, 0, sizeof(nc->transmit_timestamp));
+
+		// NTPパケット送信
+		ntp_cli_time_synchronization(nc, NTP_MODE_CLIENT);
+
+		// NTP応答待ちに遷移、500msでリトライ
+		nc->state = NTP_CLI_STATE_REQUEST;
+		nc->timer = 500 * 1000;
+		break;
+	}
+}
+
+ER ntp_cli_time_synchronization(T_NTP_CLI_CONTEXT *nc, ntp_mode_t mode)
+{
+	ER_UINT	len = sizeof(nc->ntp_msg);
+	T_NTP_MSG *ntp = &nc->ntp_msg;
+	ER error;
+
+	memset(ntp, 0, len);
+
+	ntp->leap_indicator = 0;
+	ntp->version_number = 4;
+	ntp->mode = mode;
+	ntp->stratum = (mode == NTP_MODE_CLIENT) ? 2 : 1;
+	ntp->poll = nc->poll;
+	ntp->precision = 0xfa;   // 精度は10^-6(1μs)
+	ntp->root_delay = htonl(0);
+	ntp->root_dispersion = htonl(0);
+	// 同期のための外部的な手段のないサブネット
+	ntp->reference_identifier[0] = 'L';
+	ntp->reference_identifier[1] = 'O';
+	ntp->reference_identifier[2] = 'C';
+	ntp->reference_identifier[3] = 'L';
+	// 参照タイムスタンプ
+	memcpy(&ntp->reference_timestamp, &nc->reference_timestamp, sizeof(ntp->reference_timestamp));
+	// 開始タイムスタンプ
+	memcpy(&ntp->originate_timestamp, &nc->originate_timestamp, sizeof(ntp->originate_timestamp));
+	// 受信タイムスタンプ
+	memcpy(&ntp->receive_timestamp, &nc->receive_timestamp, sizeof(ntp->receive_timestamp));
+	// 送信タイムスタンプ
+	memcpy(&ntp->transmit_timestamp, &nc->transmit_timestamp, sizeof(ntp->transmit_timestamp));
+	// 鍵識別子
+	ntp->key_identifier[0] = 0x08;
+	ntp->key_identifier[1] = 0x18;
+	ntp->key_identifier[2] = 0x00;
+	ntp->key_identifier[3] = 0x00;
+
+	if ((error = udp_snd_dat(nc->cepid, &nc->snd_rmt, ntp, len, TMO_NBLK)) != E_WBLK) {
+		syslog(LOG_NOTICE, "[NTP CLI,%d] udp_snd_dat error: %s",
+			nc->cepid, itron_strerror(error));
+		return error;
+	}
+	else
+		syslog(LOG_DEBUG, "[NTP CLI,%d] udp_snd_dat: to: %s.%d\n",
+			nc->cepid, ip2str(NULL, &nc->snd_rmt.ipaddr), nc->snd_rmt.portno);
+
+	return E_OK;
+}
+
+void ntp_cli_read_time(T_NTP_CLI_CONTEXT *nc, struct timespec *tp)
+{
+	SYSTIM time;
+	ER ret;
+
+	ret = get_tim(&time);
+	if (ret != E_OK) {
+		syslog(LOG_NOTICE, "[NTP CLI,%d] get_tim error: %s",
+			nc->cepid, itron_strerror(ret));
+		tp->tv_sec = 0;
+		tp->tv_nsec = 0;
+		return;
+	}
+
+	tp->tv_sec = time / 1000000ll;
+	tp->tv_nsec = (time % 1000000ll) * 1000ll;
+}
+
+void ntp_cli_write_time(T_NTP_CLI_CONTEXT *nc, struct timespec *tp)
+{
+	SYSTIM time;
+	ER ret;
+
+	time = (tp->tv_sec * 1000000ll) + (tp->tv_nsec / 1000ll);
+
+	ret = set_tim(time);
+	if (ret != E_OK) {
+		syslog(LOG_NOTICE, "[NTP CLI,%d] set_tim error: %s",
+			nc->cepid, itron_strerror(ret));
+	}
+}
+
+/*
+ *  ノンブロッキングコールのコールバック関数
+ */
+
+ER
+callback_nblk_ntp_cli (ID cepid, FN fncd, void *p_parblk)
+{
+	T_NTP_CLI_CONTEXT *nc = &ntp_cli;
+	ER_UINT len;
+
+	len = *(ER_UINT*)p_parblk;
+	if (len < 0 && len != E_RLWAI) {
+		/* E_RLWAI 以外で、0 以下の場合は、エラーを意味している。*/
+		syslog(LOG_NOTICE, "[NTP CLI,%d] callback error: %s, fncd: %s", nc->cepid,
+			itron_strerror(len), in_strtfn(fncd));
+	}
+	else {
+		if (fncd == TEV_UDP_RCV_DAT) {
+			if ((len = udp_rcv_dat(nc->cepid, &nc->rcv_rmt, &nc->ntp_msg, len, TMO_POL)) < 0)
+			{
+				syslog(LOG_NOTICE, "[NTP CLI,%d] udp_rcv_dat error: %s", nc->cepid,
+					itron_strerror(len));
+			}
+			else
+				syslog(LOG_DEBUG, "[NTP CLI,%d] udp_rcv_dat len: %d", nc->cepid, len);
+
+			if (len >= sizeof(nc->ntp_msg))
+				nc->rcv_flag = len;
+			else
+				nc->rcv_flag = 0;
+		}
+		syscall(wup_tsk(nc->tskid));
+	}
+
+	return E_OK;
+}
+
+#ifdef NTP_CLI_TASK
+
+/*
+ *  NTP クライアント送信タスク
+ */
+
+void
+ntp_cli_task (intptr_t exinf)
+{
+	T_NTP_CLI_CONTEXT *nc = &ntp_cli;
+	ER		error, ret;
+	SYSTIM		prev, time;
+	int timer;
+
+	get_tid(&nc->tskid);
+	syslog(LOG_NOTICE, "[NTP CLI:%d,%d] started.", nc->tskid, (ID)exinf);
+
+	/* 初期化 */
+	ntp_cli_initialize(nc, (ID)exinf);
+
+	ret = get_tim(&time);
+	if (ret != E_OK) {
+		syslog(LOG_NOTICE, "[NTP CLI,%d] get_tim error: %7lu,%s",
+			nc->cepid, time / SYSTIM_HZ, itron_strerror(ret));
+		return;
+	}
+
+	while (true) {
+		prev = time;
+
+		/* タイマー取得 */
+		timer = ntp_cli_get_timer(nc);
+
+		/* 待ち */
+		error = tslp_tsk(timer);
+		if ((error != E_OK) && (error != E_TMOUT)) {
+			syslog(LOG_NOTICE, "[NTP CLI,%d] tslp_tsk error: %s %d",
+				nc->cepid, itron_strerror(error), timer);
+			break;
+		}
+
+		ret = get_tim(&time);
+		if (ret != E_OK) {
+			syslog(LOG_NOTICE, "[NTP CLI,%d] get_tim error: %s",
+				nc->cepid, itron_strerror(ret));
+			break;
+		}
+
+		/* 時間経過 */
+		ntp_cli_progress(nc, time - prev);
+
+		/* 起こされた場合 */
+		if (error == E_OK) {
+			ntp_cli_wakeup(nc);
+		}
+
+		/* タイムアウト処理 */
+		ntp_cli_timeout(nc);
+	}
+}
+
+#endif
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/src/ntp_cli.cfg
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/src/ntp_cli.cfg	(revision 340)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/src/ntp_cli.cfg	(revision 340)
@@ -0,0 +1,51 @@
+/*
+ *  TOPPERS ECHONET Lite Communication Middleware
+ * 
+ *  Copyright (C) 2018 Cores Co., Ltd. Japan
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  @(#) $Id: ntp_cli.cfg 1496 2018-04-12 11:59:40Z coas-nagasima $
+ */
+
+/*
+ *  NTP クライアントのシステムコンフィギュレーションファイル
+ */
+
+/* タスク */
+
+CRE_TSK(NTP_CLI_TASK, {
+	TA_HLNG|TA_ACT,
+	NTP_CLI_CEPID,
+	ntp_cli_task,
+	NTP_CLI_MAIN_PRIORITY,
+	NTP_CLI_STACK_SIZE,
+	NULL
+	});
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/src/ntp_cli.h
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/src/ntp_cli.h	(revision 340)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/src/ntp_cli.h	(revision 340)
@@ -0,0 +1,132 @@
+/*
+ *  TOPPERS ECHONET Lite Communication Middleware
+ * 
+ *  Copyright (C) 2018 Cores Co., Ltd. Japan
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  @(#) $Id: ntp_cli.h 1496 2018-04-12 11:59:40Z coas-nagasima $
+ */
+
+#ifndef _NTP_CLI_H_
+#define _NTP_CLI_H_
+
+/* スタックサイズ */
+
+#define NTP_CLI_STACK_SIZE	1024		/* NTP クライアントタスク（IPv4）のスタックサイズ	*/
+
+/* 優先度 */
+
+#define NTP_CLI_MAIN_PRIORITY	5		/* NTP クライアントタスク（IPv4）の優先度		*/
+
+/* タスク */
+
+extern void	ntp_cli_task(intptr_t exinf);
+
+/* NTPタイムスタンプ */
+typedef struct ntp_timestamp {
+	uint32_t integer;
+	uint32_t fraction;
+} __attribute__((packed)) T_NTP_TIMESTAMP;
+
+/* NTPパケット */
+typedef struct ntp_msg {
+	uint8_t mode : 3;
+	uint8_t version_number : 3;
+	uint8_t leap_indicator : 2;
+	uint8_t stratum;
+	uint8_t poll;
+	uint8_t precision;
+	uint32_t root_delay;
+	uint32_t root_dispersion;
+	uint8_t reference_identifier[4];
+	T_NTP_TIMESTAMP reference_timestamp;
+	T_NTP_TIMESTAMP originate_timestamp;
+	T_NTP_TIMESTAMP receive_timestamp;
+	T_NTP_TIMESTAMP transmit_timestamp;
+	uint8_t key_identifier[4];
+	uint8_t message_digest[16];
+} __attribute__((packed)) T_NTP_MSG;
+
+typedef enum ntp_mode {
+	NTP_MODE_RESERVED,
+	NTP_MODE_SYMMETRIC_ACTIVE,
+	NTP_MODE_SYMMETRIC_PASSIVE,
+	NTP_MODE_CLIENT,
+	NTP_MODE_SERVER,
+	NTP_MODE_BROADCAST,
+	NTP_MODE_NTP_CONTROL_MESSAGE,
+	NTP_MODE_RESERVED_FOR_PRIVATE_USER
+} ntp_mode_t;
+
+/* NTPクライアント状態 */
+typedef enum ntp_cli_state {
+	NTP_CLI_STATE_ASYNC,
+	NTP_CLI_STATE_RESOLVE_ADDR,
+	NTP_CLI_STATE_REQUEST,
+	NTP_CLI_STATE_SYNC,
+} ntp_cli_state_t;
+
+typedef struct ntp_cli {
+	ntp_cli_state_t state;
+	int timer;
+	int retry;
+#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4)
+	T_IN6_ADDR	ipaddr6;
+#endif
+	uint16_t portno;
+	ID tskid;
+	ID cepid;
+	T_NTP_MSG ntp_msg;
+	T_IPV4EP snd_rmt;
+	T_IPV4EP rcv_rmt;
+	uint8_t poll;
+	T_NTP_TIMESTAMP reference_timestamp;
+	T_NTP_TIMESTAMP originate_timestamp;
+	T_NTP_TIMESTAMP receive_timestamp;
+	T_NTP_TIMESTAMP transmit_timestamp;
+	T_NTP_TIMESTAMP recv_resp_timestamp;
+	char buf[30];
+	int rcv_flag;
+	int exe_flag;
+} T_NTP_CLI_CONTEXT;
+
+/* 関数 */
+
+void ntp_cli_initialize(T_NTP_CLI_CONTEXT *nc, ID cepid);
+int ntp_cli_get_timer(T_NTP_CLI_CONTEXT *nc);
+void ntp_cli_progress(T_NTP_CLI_CONTEXT *nc, TMO elapse);
+void ntp_cli_wakeup(T_NTP_CLI_CONTEXT *nc);
+void ntp_cli_timeout(T_NTP_CLI_CONTEXT *nc);
+ER callback_nblk_ntp_cli(ID cepid, FN fncd, void *p_parblk);
+
+void ntp_cli_execute();
+
+#endif	/* of #ifndef _NTP_CLI_H_ */
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/src/ntshell_main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/src/ntshell_main.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/src/ntshell_main.c	(revision 340)
@@ -125,18 +125,26 @@
 {
 	const cmd_table_t *p = cmd_table_info.table;
+	int result = 0;
+	int found = 0;
+
 	if (strcmp((const char *)args[1], "help") == 0) {
-		usrcmd_help(args[0], (char **)&args[1]);
+		found = 1;
+		result = usrcmd_help(args[0], (char **)&args[1]);
 	}
 	else for (int i = 0; i < cmd_table_info.count; i++) {
 		if (strcmp((const char *)args[1], p->cmd) == 0) {
-			return p->func(args[0], (char **)&args[1]);
+			found = 1;
+			result = p->func(args[0], (char **)&args[1]);
+			break;
 		}
 		p++;
 	}
-	/*if (setjmp(process_exit) == 0) {
-		main(args);
-	}*/
+
+	if ((found == 0) && (((const char *)args[1])[0] != '\0'))
+		printf("Unknown command found.\n");
+
 	clean_fd();
-	return 0;
+
+	return result;
 }
 
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/src/shellif.h
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/src/shellif.h	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/src/shellif.h	(revision 340)
@@ -40,9 +40,11 @@
 #ifdef _MSC_VER
 #define _CRT_NO_TIME_T
+#define tm msc_tm
 #include <time.h>
 #include <errno.h>
 #include <limits.h>
 #include <stdlib.h>
-#define restrict __restrict
+#undef tm
+#undef NULL
 #endif
 
@@ -106,4 +108,5 @@
 #include "../musl-1.1.18/include/bits/stat.h"
 #include "../musl-1.1.18/include/sys/select.h"
+#include "../musl-1.1.18/include/time.h"
 #include "../musl-1.1.18/include/signal.h"
 #include "../musl-1.1.18/include/stdio.h"
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/src/syscall.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/src/syscall.c	(revision 339)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/src/syscall.c	(revision 340)
@@ -60,5 +60,5 @@
 	switch (n) {
 	case SYS__llseek:
-		return shell_llseek(va_arg(ap, int), ((va_arg(ap, off_t)) << 32) + va_arg(ap, off_t), va_arg(ap, off_t *), va_arg(ap, int));
+		return shell_llseek(va_arg(ap, int), va_arg(ap, off_t), va_arg(ap, off_t *), va_arg(ap, int));
 	case SYS__newselect:
 		ret = shell_select(va_arg(ap, int), va_arg(ap, fd_set *), va_arg(ap, fd_set *), va_arg(ap, fd_set *), va_arg(ap, struct timeval *));
@@ -253,5 +253,5 @@
 		break;
 	case SYS_ftruncate64:
-		ret = shell_ftruncate(va_arg(ap, int), ((va_arg(ap, off_t)) << 32) + va_arg(ap, off_t));
+		ret = shell_ftruncate(va_arg(ap, int), va_arg(ap, off_t));
 		break;
 	case SYS_futex:
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/src/tinet_ntp_cli.cfg
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/src/tinet_ntp_cli.cfg	(revision 340)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/src/tinet_ntp_cli.cfg	(revision 340)
@@ -0,0 +1,45 @@
+/*
+ *  TINET (UDP/IP Protocol Stack)
+ * 
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
+ *                   Tomakomai National College of Technology, JAPAN
+ *
+ *  上記著作権者は，以下の (1)～(4) の条件か，Free Software Foundation 
+ *  によって公表されている GNU General Public License の Version 2 に記
+ *  述されている条件を満たす場合に限り，本ソフトウェア（本ソフトウェア
+ *  を改変したものを含む．以下同じ）を使用・複製・改変・再配布（以下，
+ *  利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次の条件を満たすこと．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，その適用可能性も
+ *  含めて，いかなる保証も行わない．また，本ソフトウェアの利用により直
+ *  接的または間接的に生じたいかなる損害に関しても，その責任を負わない．
+ * 
+ *  @(#) $Id: tinet_ntp_cli.cfg 1291 2017-07-20 02:51:05Z coas-nagasima $
+ */
+
+/*
+ *  NTP クライアント
+ *  TCP/IP コンフィギュレーションファイル
+ */
+
+/* UDP 通信端点 */
+
+UDP_CRE_CEP (NTP_CLI_CEPID, {
+	0,
+	{ IPV4_ADDRANY, UDP_PORTANY },
+	callback_nblk_ntp_cli
+	} );
